/*
 * Copyright (c) 2001-2002 Conexant Systems, Inc.
 * 
 * 1.   Permitted use. Redistribution and use in source and binary forms,
 * with or without modification, are permitted under the terms set forth
 * herein.
 * 
 * 2.   Disclaimer of Warranties. CONEXANT AND OTHER CONTRIBUTORS MAKE NO
 * REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
 * IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
 * CONEXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.
 * 
 * This software has not been formally tested, and there is no guarantee that
 * it is free of errors including, but not limited to, bugs, defects,
 * interrupted operation, or unexpected results. Any use of this software is
 * at user's own risk.
 * 
 * 3.   No Liability.
 * 
 * (a) Conexant or contributors shall not be responsible for any loss or
 * damage to Company, its customers, or any third parties for any reason
 * whatsoever, and CONEXANT OR CONTRIBUTORS SHALL NOT BE LIABLE FOR ANY
 * ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 * WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 * 
 * (b) User agrees to hold Conexant and contributors harmless from any
 * liability, loss, cost, damage or expense, including attorney's fees,
 * as a result of any claims which may be made by any person, including
 * but not limited to User, its agents and employees, its customers, or
 * any third parties that arise out of or result from the manufacture,
 * delivery, actual or alleged ownership, performance, use, operation
 * or possession of the software furnished hereunder, whether such claims
 * are based on negligence, breach of contract, absolute liability or any
 * other legal theory.
 * 
 * 4.   Notices. User hereby agrees not to remove, alter or destroy any
 * copyright, trademark, credits, other proprietary notices or confidential
 * legends placed upon, contained within or associated with the Software,
 * and shall include all such unaltered copyright, trademark, credits,
 * other proprietary notices or confidential legends on or in every copy of
 * the Software.
 * 
 */

/****************************************************************************************
*                     Version Control Information								
*
*                                                                                       *
* $Header:   P:/d942/octopus/archives/Include/framewrk.h_v   1.47   16 Dec 2002 17:15:14   beliloi  $
* 
*****************************************************************************************/


/****************************************************************************************

File Name:			framewrk.h	

File Description:	Compiler Directives for code modules

*****************************************************************************************/

/****************************************************************************************
TARGETS SUPPORTED				
TARGET_HCF_PCI_WDM				
TARGET_HCF_PCI_VXD				
TARGET_HCF_USB_WDM				
TARGET_HCF_USB_MACOS9			
TARGET_HCF_USB_MACOSX			
TARGET_HCF_PCI_MACOSX			
TARGET_HSF_PCI_MACOSX
TARGET_HCF_PCI_LINUX
TARGET_HCF_USB_LINUX
****************************************************************************************/
#ifndef __FRAMEWORK_H__
#define __FRAMEWORK_H__

/****************************************************************************************
	Octopus modem family settings
****************************************************************************************/
#define OCTOPUS_MODEM

/****************************************************************************************
	HCF PCI WDM settings
****************************************************************************************/
#if defined TARGET_HCF_PCI_WDM
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define VOICE_SUPPORT
/*#$YS$ */
#define FAX34_ENABLE 1

//#define NO_VOICE_SUPPORT
/* JT has to enable voice support before using this feature */
#define SUPPORT_DTMF_CID		

#define NO_V80_SUPPORT
#define NO_BLAM_SUPPORT
#define NO_DUMPMGR_SUPPORT
/* #define USE_SMART_DAA */

/*#define TEST_CWCID */
/*#define BLAM */
#if DBG
#define _DEBUG 1
#endif
/****************************************************************************************
	HCF PCI VxD settings
****************************************************************************************/
#elif defined TARGET_HCF_PCI_VXD
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
/*#define BLAM */

/****************************************************************************************
	HCF USB WDM settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_WDM
#define FRAMEWORK_HCF_PCI		0
#define FRAMEWORK_HCF_CADMUS2	1
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define MODEM_VXD 0		/* for VxD only or VxD/SYS combination */
#define MODEM_WDM 1		/* WDM modem */
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_TEST_SESSION
/*#define BLAM */
/*#define USE_DCP */
#define CADMUS2	1

#if DBG
#define _DEBUG 1
#endif

#define XID_TIMEOUT_RENEG	/* rmy: to fix XID rx problem */
#define USE_TOTAL_SIGNATURE_CHECK
/*#define DP_CLOCK_WA_STAT */
/*#define LOOPBACK_RETRAIN */

#define NO_VOICE_SUPPORT
#define NO_V80_SUPPORT
#define NO_DTMF_CID_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_BLAM_SUPPORT
#define NO_V34FAX_SUPPORT
#define NO_DIAGMGR_SUPPORT

/****************************************************************************************
	MacOS9 settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_MACOS9
#define USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_TEST_SESSION
#define FRAMEWORK_HCF_CADMUS2 1
#define CADMUS2	1
#define MACTOPUS
#define BIG_ENDIAN_MACHINE 1
#define SAVE_TXRX_STATES
#define USE_DCP
#define FAKE_PULSEDIAL_DCP
#define XID_TIMEOUT_RENEG	/* rmy: to fix XID rx problem */
/*#define BLAM */

#define _stdcall
#define __stdcall

#define USE_LOOPBACK_RESTART

#define NO_VOICE_SUPPORT
#define NO_V80_SUPPORT
#define NO_DIAGMGR_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_DTMF_CID_SUPPORT
#define NO_BLAM_SUPPORT

/****************************************************************************************
	MacOSX settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_MACOSX
#define USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_TEST_SESSION
#define FRAMEWORK_HCF_CADMUS2 1
#define CADMUS2	1
#define MACTOPUS
#define BIG_ENDIAN_MACHINE 1
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_DCP
#define FAKE_PULSEDIAL_DCP
#define XID_TIMEOUT_RENEG	/* rmy: to fix XID rx problem */
/* #define BLAM */

#define _stdcall
#define __stdcall

#define NO_VOICE_SUPPORT
#define NO_V80_SUPPORT
#define NO_V34FAX_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_DTMF_CID_SUPPORT
#define NO_BLAM_SUPPORT

#define USE_LOOPBACK_RESTART

/****************************************************************************************
	MacOSX HCF PCI settings
****************************************************************************************/
#elif defined TARGET_HCF_PCI_MACOSX 

#undef USE_DIRECT_API
#define USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_TEST_SESSION
#define FRAMEWORK_HCF_CADMUS2 0
#define BIG_ENDIAN_MACHINE 1
#define MACTOPUS
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_DCP
#define FAKE_PULSEDIAL_DCP
#define XID_TIMEOUT_RENEG	/* rmy: to fix XID rx problem */
#define DUMP_MANAGER
#define BLAM

#define _stdcall
#define __stdcall

#define NO_VOICE_SUPPORT
#define NO_V80_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_DTMF_CID_SUPPORT

#define USE_LOOPBACK_RESTART

/****************************************************************************************
	MacOSX HSF PCI settings
****************************************************************************************/
#elif defined TARGET_HSF_PCI_MACOSX
#undef USE_DIRECT_API
#define USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_TEST_SESSION
#define FRAMEWORK_HCF_CADMUS2 0
#define BIG_ENDIAN_MACHINE 1
#define MACTOPUS
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_DCP
#define FAKE_PULSEDIAL_DCP
#define XID_TIMEOUT_RENEG	/* rmy: to fix XID rx problem */
#define DUMP_MANAGER
#define BLAM

#define _stdcall
#define __stdcall
#include "build_modules.h"

/* BLAM interface to be hidden from system namespace */
#undef  RPT_Write
#define RPT_Init            InternalSoftModem_RPT_Init
#define RPT_SetMask         InternalSoftModem_RPT_SetMask
#define RPT_Shutdown        InternalSoftModem_RPT_Shutdown
#define RPT_Write           InternalSoftModem_RPT_Write
#define RPT_Read            InternalSoftModem_RPT_Read
#define GetIOClientFromId   InternalSoftModem_GetIOClientFromId

#define USE_LOOPBACK_RESTART
/* SoftModem section from HSF's framewrk.h" */
#define PROJECT     PRJ_HSF
#define PRJ_FLAVOUR	PRJFLVR_CYPRUS
#define OS_TYPE     OS_MACOS
#define UK_MODE     UK_KERNEL
#define CPU_TYPE    CPU_PPC
#define CPU_VER     4000
#define IO_MODE     IO_ONLINE
#define COMPILER    CMP_GCC
#define CMP_VER     5
#define DEV_TOOL    DT_NONE
#define DEBUG_LEVEL DEBUG_DEVELOP
#define OCT_SW_MODEM 1
#define OCT_MEM_MGR	1
#define USE_MEM_MGR	1
#define USE_PRAGMA_PACK	0
#define OS_NOREDEFS
#define DMP

#undef FRAME_WORK
#define FRAME_WORK "Framework: MacOS X HSF"

/****************************************************************************************
	HCF PCI LINUX settings
****************************************************************************************/
#elif defined TARGET_HCF_PCI_LINUX
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define USE_SMART_DAA
#define VOICE_SUPPORT
#define FAX34_ENABLE 1
#define SUPPORT_RIPTIDE
#define USE_PRAGMA_PACK 0
/*#define TEST_CWCID */
/*#define BLAM */

#define NO_V80_SUPPORT
#define NO_DIAGMGR_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_DTMF_CID_SUPPORT
#define NO_BLAM_SUPPORT

/****************************************************************************************
	HCF USB LINUX settings
****************************************************************************************/
#elif defined TARGET_HCF_USB_LINUX
#define FRAMEWORK_HCF_PCI		0
#define FRAMEWORK_HCF_CADMUS2	1
#define	USE_DIRECT_API
#define USE_DEVMGR_DIRECT_API
#define SAVE_TXRX_STATES
#define SAVE_MOH_STATES
#define USE_TEST_SESSION
#define USE_PRAGMA_PACK 0
/*#define BLAM */
/*#define USE_DCP */
#define CADMUS2	1

#define _stdcall
#define __stdcall

#define XID_TIMEOUT_RENEG	/* rmy: to fix XID rx problem */
#define USE_TOTAL_SIGNATURE_CHECK
/*#define DP_CLOCK_WA_STAT */
/*#define LOOPBACK_RETRAIN */

#define NO_VOICE_SUPPORT
#define NO_V80_SUPPORT
#define NO_DIAGMGR_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_DTMF_CID_SUPPORT
#define NO_BLAM_SUPPORT

/****************************************************************************************
	HCF VxWorks settings
****************************************************************************************/
#elif defined TARGET_HCF_PCI_VXWORKS
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
/*#define BLAM */
#define _VXWORKS

#define NO_VOICE_SUPPORT
#define NO_V80_SUPPORT
#define NO_DIAGMGR_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_DTMF_CID_SUPPORT
#define NO_BLAM_SUPPORT

#elif defined TARGET_HCF_STARFISH_VXWORKS
#define FRAMEWORK_HCF_PCI		1
#define FRAMEWORK_HCF_CADMUS2	0
#define SAVE_TXRX_STATES
#define	USE_DIRECT_API
#if 1
#define BLAM
#define USE_TRACE
#define USE_BREAKPOINT
#define TCP_BLAM_SERVER /* send BLAM writed thrue TCP port */
#endif
#define _VXWORKS

#define NO_VOICE_SUPPORT
#define NO_V80_SUPPORT
#define NO_DIAGMGR_SUPPORT
#define NO_DUMPMGR_SUPPORT
#define NO_DTMF_CID_SUPPORT

#else
#error valid build target not found

#endif	/* TARGET_XXX_YYY_ZZZ */

#if (defined TARGET_HCF_PCI_LINUX || defined TARGET_HCF_USB_LINUX) && defined __GNUC__
/* MacOS X compiler, while being GNU C does not like __attribute__((packed)) */

/* To make structures packed (with no padding), do:
 *    typedef struct PACKED_ATTRIB st_TAG { ... } st_T; */
#define PACKED_ATTRIB __attribute__ ((packed))
#define ALIGNED_ATTRIB(n) __attribute__ ((packed, aligned(n)))
#else
#define PACKED_ATTRIB
#define ALIGNED_ATTRIB(n)
#endif

#endif /* __FRAMEWORK_H__ */
